#!/usr/bin/python
# Author: Theodore Zacharia
# V0.1: 03/08/2021 - Initial Release
#
# This script provides a template to start all other scripts with
# supports arguments being passed
#
# The canonical solution in the standard library is argparse
# but there is also a getopt solution which keeps it the same as a shell script
#
# There are a LOT of options for multi threading/processing/asynchronous work
# This template uses Threads
# 
#
import sys
import os, getopt
import threading
import time
from threading import *
from datetime import datetime


# ****************************************************
# Globals
trace = 0
max_threads = 20   # max number of concurrent threads to allow
sleep_time = 3     # time in seconds to wait when max number of threads running

# ****************************************************
# Functions

def usage():
	print ('[-h] [-t|-T] [-M maxthreads] [-a argvalue] [-b myarg1value|--myarg1 myarg1value] [-c myarg2value|--myarg2 myarg2value] positional_params')
	print ("where:")
	print (" -h displays this help message")
	print (" -t is trace mode, -T is more trace info")
	print (" -a is an arg value")
	print ("Examples:")
	print ("python ", sys.argv[0] , "-t -a avalue")

	#print (msg)

def getargs():
	global trace
	global max_threads

	try:
		opts, args = getopt.getopt(sys.argv[1:],"hTtHa:b:c:",["myarg1=","myarg2="])
	except getopt.GetoptError as err:
		print (err)
		sys.exit(2)
	for opt, arg in opts:
		print ("checking opt=", opt)
		if opt == '-h':
			usage()
			sys.exit()
		if opt == '-t':
			trace=1  # set trace level
		elif opt == '-T':
			trace=2  # set trace level higher
		elif opt == '-M':
			max_threads=arg
		elif opt == '-a':
			print ("1")
			print ("arg -a is ", "sss", arg)
			# dict_infile = arg.replace('"', 'Z')
		elif opt in ("-b", "--myarg1"):
			print ("2")
			print ("arg -b or --myarg1 is ", arg)
		elif opt in ("-c", "--myarg1"):
			print ("3")
			print ("arg -c or --myarg2 is ", arg)


	print ("args=", args)


class mymultithreadedclass(Thread):
	def mymultithreadedfunc(self, *msg):
		print ("running func ", get_ident(), " with ", msg)
		time.sleep (5)


# ****************************************************
# Mainline


getargs()

if len(sys.argv) > 1:
	if trace > 0:
		if trace > 1:
			current_time = datetime.now()
		else:
			current_time = time.ctime()
		print ("Starting at", current_time)
		print ("args processed")
		print (sys.argv)



DOSOMETHING=0
app1 = mymultithreadedclass()

while DOSOMETHING < 100 :
	DOSOMETHING +=1
	THREADS=threading.active_count()
	if trace > 0 :
		print ("THREADS=",THREADS," at DOSOMETHING=",DOSOMETHING)
	while THREADS >= max_threads :
		print ("waiting in ", get_ident(), " with ", THREADS," threads")
		time.sleep (sleep_time)
		THREADS=threading.active_count()


	t1 = Thread(target=app1.mymultithreadedfunc, args=("hello there","monkey"))
	t1.start()	




